SystemOrganization addCategory: #GODSpreadsheet!

GODData subclass: #SSSpreadsheetData
	instanceVariableNames: 'sheets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSpreadsheet'!

!SSSpreadsheetData class methodsFor: 'initializing' stamp: 'dhk 10/2/2014 21:33'!
fromFile: filePath
	"initialize a SSSpreadsheetData from specified path"

	^SSSpreadsheetData new! !

!SSSpreadsheetData methodsFor: 'adding' stamp: 'dhk 10/2/2014 21:33'!
createSheetWithName: name
	|sheet|
	sheet := SSSheet new: name.
	sheets add s.
	^sheet! !

!SSSpreadsheetData methodsFor: 'accessing' stamp: 'dhk 9/27/2014 15:11'!
getSheet: sheetNumber
	"returns the sheet with the sheetNumber index"
	
	^SSSheet new! !

!SSSpreadsheetData methodsFor: 'accessing' stamp: 'dhk 9/27/2014 15:12'!
getSheetWithName: sheetName
	"returns the sheet with name sheetName"

	^SSSheet new! !

!SSSpreadsheetData methodsFor: 'accessing' stamp: 'dhk 9/27/2014 17:23'!
numberOfSheets
	"returns how many sheets exists in this GODSpreadsheetData"

	^sheets size! !

!SSSpreadsheetData methodsFor: 'accessing' stamp: 'dhk 9/27/2014 17:18'!
renameSheet: sheetName toName: aName
	"renames a sheet"! !

!SSSpreadsheetData methodsFor: 'file out' stamp: 'dhk 10/2/2014 21:51'!
toFile: filePath
	"save this SSSpreadsheetData to specified path. Returns false if there is an error"

	^true! !

Object subclass: #SSCell
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSpreadsheet'!

!SSCell methodsFor: 'accessing' stamp: 'foa 9/27/2014 18:51'!
getColumn
	"Return the column name of this cell."

	^'column name'! !

!SSCell methodsFor: 'accessing' stamp: 'foa 9/27/2014 18:51'!
getColumnIndex
	"Returns the column index of this cell."

	^0! !

!SSCell methodsFor: 'accessing' stamp: 'foa 9/27/2014 18:50'!
getParentRow
	"Returns the Row which this cell belongs to."

	^SSRow new.! !

!SSCell methodsFor: 'accessing' stamp: 'foa 9/27/2014 18:50'!
getRowIndex
	"Returns the row index of this cell. "

	^0.! !

!SSCell methodsFor: 'accessing' stamp: 'dhk 10/2/2014 21:40'!
value
	"returns the value of this cell"

	^value! !

!SSCell methodsFor: 'accessing' stamp: 'dhk 10/2/2014 21:40'!
value: aValue
	"set the value of this cell"

	value := aValue! !

Object subclass: #SSRow
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSpreadsheet'!

!SSRow methodsFor: 'adding' stamp: 'dhk 9/27/2014 16:45'!
addCell: aCell atColumn: columnName
	"add aCell at the column with name columnName"! !

!SSRow methodsFor: 'adding' stamp: 'dhk 9/27/2014 16:38'!
addCell: aCell atColumnIndex: columnIndex
	"add a cell in this row at the specified column index"! !

!SSRow methodsFor: 'deleting' stamp: 'dhk 9/27/2014 16:46'!
deleteCell: columnName
	"delete the cell at column with name columnName"! !

!SSRow methodsFor: 'deleting' stamp: 'dhk 9/27/2014 16:46'!
deleteCellAtIndex: columnIndex
	"delete the cell at specified column index"! !

!SSRow methodsFor: 'accessing' stamp: 'dhk 9/27/2014 15:46'!
getCell: columnName
	"get the cell in this row at the column with name columnName"

	^SSCell new! !

!SSRow methodsFor: 'accessing' stamp: 'dhk 9/27/2014 16:06'!
getCellAtIndex: columnIndex
	"get the cell in this row at columnIndex"

	^SSCell new! !

!SSRow methodsFor: 'accessing' stamp: 'foa 9/27/2014 18:49'!
getParentSheet
	"Returns the sheet which this row belongs to."

	^SSSheet new.! !

!SSRow methodsFor: 'accessing' stamp: 'dhk 10/2/2014 21:39'!
index
	"Returns the index (number) of this row in the parent sheet."

	^0.! !

Object subclass: #SSSheet
	instanceVariableNames: 'sheetName rows columnNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODSpreadsheet'!

!SSSheet class methodsFor: 'instance creation' stamp: 'dhk 9/27/2014 16:35'!
new: aName
	^(self new) changeName: aName! !

!SSSheet methodsFor: 'private' stamp: 'dhk 9/27/2014 16:39'!
changeName: aName
	"change the name of this sheet"

	sheetName := aName! !

!SSSheet methodsFor: 'adding' stamp: 'dhk 9/27/2014 16:42'!
createRow
	"creates a new empty row after the last row in this sheet"

	^SSRow new.! !

!SSSheet methodsFor: 'adding' stamp: 'dhk 9/27/2014 16:43'!
createRowAtIndex: aIndex
	"creates a new empty row at specified index in this sheet"

	^SSRow new.! !

!SSSheet methodsFor: 'deleting' stamp: 'foa 9/27/2014 18:35'!
deleteRow: aIndex
	"delete row at index aIndex"! !

!SSSheet methodsFor: 'accessing' stamp: 'dhk 9/27/2014 16:02'!
getCellAtRow: rowIndex atColumn: columnName
	"returns the cell at this specified address"

	^SSCell new! !

!SSSheet methodsFor: 'accessing' stamp: 'dhk 9/27/2014 16:02'!
getCellAtRow: rowIndex atColumnIndex: columnIndex
	"returns the cell at this specified address"

	^SSCell new! !

!SSSheet methodsFor: 'accessing' stamp: 'foa 9/27/2014 18:46'!
getColumnNames
	"Returns the ordered list of column names of this sheet."

	^columnNames! !

!SSSheet methodsFor: 'accessing' stamp: 'dhk 10/2/2014 21:33'!
getParentSpreadsheet
	"return the SSSpreadsheetData which this sheet belongs to"

	^SSSpreadsheetData new.! !

!SSSheet methodsFor: 'accessing' stamp: 'dhk 9/27/2014 15:07'!
getRow: rowIndex
	"returns the row with the specified index"

	^SSRow new! !

!SSSheet methodsFor: 'accessing' stamp: 'dhk 10/2/2014 21:38'!
index
	"return the index of this sheet in the SpreadsheetData"

	^0.! !

!SSSheet methodsFor: 'accessing' stamp: 'dhk 10/2/2014 21:39'!
name
	"returns the name of this sheet"

	^sheetName! !
